#include <cstdio>
#include <cstring>

const int mod = 1000000007;

int n, m;
long long ad[128][128];

int x, y, l;

long long res[128][128];
long long tmp[128][128];

void matmult(long long c[128][128], long long a[128][128], long long b[128][128]) {
  memset(c, 0, sizeof(res));
  for (int i = 1; i <= n; ++i) {
      for (int j = 1; j <= n; ++j) {
    for (int k = 1; k <= n; ++k) {
        c[i][j] += a[i][k] * b[k][j];
        if (c[i][j] >= mod) {
          c[i][j] %= mod;
        }
      }
    }
  }
}

void qpow(long long m[128][128], long long st) {
  memset(res, 0, sizeof(res));
  for (int i = 1; i <= n; ++i) {
    res[i][i] = 1;
  }

  while (st) {
    if (st & 1) {
      memcpy(tmp, res, sizeof(res));
      matmult(res, tmp, m);
    }
    st /= 2;
    matmult(tmp, m, m);
    memcpy(m, tmp, sizeof(tmp));
  }
  memcpy(m, res, sizeof(res));
}

int main() {
  scanf("%d %d", &n, &m);
  memset(ad, 0, sizeof(ad));
  for (int i = 0; i < m; ++i) {
    int j, k;
    scanf("%d %d", &j, &k);
    ad[j][k] = ad[k][j] = 1;
  }
  scanf("%d %d %d", &x, &y, &l);

  qpow(ad, l);
  printf("%lld\n", ad[x][y]);
  return 0;
}
